<script>
import { socketStore } from '@/plugins/socket.js';
import Digit from '@/components/digit.svelte';
import { onDestroy } from 'svelte';
import { splitIntoDigits } from '@/plugins/utils';
import { topics } from '@/plugins/store.js';

let dons = 0;
let unsubscribe;
$: {
    if (!unsubscribe) {
        socketStore.update(store => {
            unsubscribe = store.subscribe(message => {
                // Do something with the message here
                try {
                    let m = JSON.parse(message)
                    if (m.msg_type == "init") {
                        let messages = m.data
                        for (let i = 0; i < messages.length; i++) {
                            if (messages[i].topic == "/dons/total") {
                                dons = messages[i].message.total
                                dons = (dons/100).toFixed(2).toString()
                            }
                        }
                    } else {
                        let message = m.data.message
                        if (m.data.topic == "/dons/total") {
                            dons = message.total
                            dons = (dons/100).toFixed(2).toString()
                        }
                    }
                } catch (e) {
                    console.log(e)
                }
            });
            return store;
        });
    }
}

// Add a topic to the socket
topics.update(store => {
    store.push("/dons/total");
    return store;
});

socketStore.update(store => {
    store.send(JSON.stringify({"topics": $topics}));
    return store;
});

onDestroy(() => {
    unsubscribe();
    // Remove the topic from the socket
    topics.update(store => {
        store.splice(store.indexOf("/dons/total"), 1);
        return store;
    });
    socketStore.update(store => {
        store.send(JSON.stringify({"topics": $topics}));
        return store;
    });
});
</script>
    
<!-- Display a counter if  -->
<div class="text-9xl font-extrabold" style="background-color:transparent">
    <div class="grid grid-flow-col text-center auto-cols-max" style="background-color:transparent">
        {#each splitIntoDigits(dons, 2) as count}
            <div class="flex flex-col justify-center" style="background-color:transparent">
                <Digit digit={count}  style="background-color:transparent"/>
            </div> 
        {/each}
        <span>€</span>
    </div>
</div>